/*	
 *	clipz80.h
 *
 *	P/ECE Z80 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_Z80_H__
#define __CLIP_Z80_H__

/****************************************************************************
 *
 ****************************************************************************/

/* Z80_ASMV{`ǂݍ݂܂B
 * Z80_ASMV{̖`/`ɂC/AZuR[h̐؂ւ́A
 * C\[Xt@C(*.c)ƃAZu\[Xt@C(*.s)QƂ̂ŁA
 * ʂ̃CN[ht@CɕĂ܂B
 * (CL̒`܂ރCN[ht@Ĉ܂܃AZu\[X
 *  CN[hƁAAZuG[ɂȂĂ܂߁B)
 */
#include "clipz80a.h"

/* ̃V{`ƁASĂ̖ߎsg[Xo͂܂B
 * ̃V{`Ȃ΁Aeߎs̓g[Xo͂܂B
 * SĂ̖ߎsg[XƂƂĂxȂ̂ŁAʏ͒`ȂłB
 * ȂÃV{`ĂAŜ̃g[XONwgTRACE_ON=1hȂ΁A
 * g[Xo͍͂s܂B
 */
//#define Z80_TRACE

/********** ȍ~͏Ȃł **********/

/* P/ECEȊOł̓AZuR[h͎gpł܂B
 */
#ifndef PIECE
#undef Z80_ASM
#endif /*PIECE*/

/* AZuR[h͑S߃g[XɑΉĂȂ̂ŁA
 * AZuR[hgp͊mɑS߃g[XOFFɂ܂B
 */
#ifdef Z80_ASM
#undef Z80_TRACE
#endif /*Z80_ASM*/ 

#ifdef Z80_TRACE
#define Z80TRACE	TRACE
#else /*Z80_TRACE*/
#define Z80TRACE	1 ? ((void)0) : TRACE
#endif /*Z80_TRACE*/

/****************************************************************************
 *
 ****************************************************************************/

typedef struct _Z80 Z80;

/*
 *	Z80RAO֐̌^`
 */
typedef unsigned char Z80READPROC (Z80* z80, unsigned short addr);
typedef          void Z80WRITEPROC(Z80* z80, unsigned short addr, unsigned char data);
typedef unsigned char Z80INPROC   (Z80* z80, unsigned short addr);
typedef          void Z80OUTPROC  (Z80* z80, unsigned short addr, unsigned char data);

/*
 *	8rbgWX^Zbg
 */
typedef struct _Z80REG8 {
	unsigned char f, a;	/* + 0, 2 */
	unsigned char c, b;	/* + 2, 2 */
	unsigned char e, d;	/* + 4, 2 */
	unsigned char l, h;	/* + 6, 2 */
} Z80REG8;			/* = 8    */

/*
 *	16rbgyAWX^Zbg
 */
typedef struct _Z80REG16 {
	unsigned short af;	/* + 0, 2 */
	unsigned short bc;	/* + 2, 2 */
	unsigned short de;	/* + 4, 2 */
	unsigned short hl;	/* + 6, 2 */
} Z80REG16;			/* = 8    */

/*
 *	8rbgWX^Zbg/16rbgyAWX^Zbgp
 */
typedef union _Z80REG {
	Z80REG8  r8;		/* + 0, 8 */
	Z80REG16 r16;		/* + 0, 8 */
} Z80REG;			/* = 8    */

/*
 *	Z80RA
 */
/*typedef*/ struct _Z80 {
	/*===== WX^ =====*/
	Z80REG reg[2];			/* + 0,16 */
	unsigned short ix;		/* +16, 2 */
	unsigned short iy;		/* +18, 2 */
	unsigned short sp;		/* +20, 2 */
	unsigned short pc;		/* +22, 2 */
	unsigned char r;		/* +24, 1 */
	unsigned char i;		/* +25, 1 */
	unsigned char _resv1[6];	/* +26, 6 */
	/*=====  =====*/
	unsigned char iff1;		/* +32, 1 */
	unsigned char iff2;		/* +33, 1 */
	unsigned char im;		/* +34, 1 */
	unsigned char halt;		/* +35, 1 */
	int cycle;			/* +36, 4 */
	unsigned char _resv2[8];	/* +40, 8 */
	/*===== O֐ =====*/
	Z80READPROC* read;		/* +48, 4 */
	Z80WRITEPROC* write;		/* +52, 4 */
	Z80INPROC* in;			/* +56, 4 */
	Z80OUTPROC* out;		/* +60, 4 */
} /*Z80*/;				/* =64    */

/*
 *	CXgNV֐錾
 */
typedef                void Z80OPPROC (Z80* z80, unsigned char code, unsigned char arg1, unsigned char arg2);
#define Z80FN_(OP, FN) void z80op_##FN(Z80* z80, unsigned char code, unsigned char arg1, unsigned char arg2);	/* 錾p */
#include "clipz8ls.h" /* [z80.xls]List!C10 */
Z80FN_("CB"   , CB   )
Z80FN_("ED"   , ED   )
Z80FN_("DD"   , DD   )
Z80FN_("FD"   , FD   )
Z80FN_("DDCB" , DDCB )
Z80FN_("FDCB" , FDCB )
Z80FN_("ERROR", ERROR)
#undef  Z80FN_
#define Z80FN_(OP, FN) void z80op_##FN(Z80* z80, unsigned char code, unsigned char arg1, unsigned char arg2)	/* `p */

/*
 *	IyR[h}bvEj[jbNe[u
 */
typedef struct _Z80OP {
	Z80OPPROC* proc;	/* + 0, 4 */
	unsigned char argc;	/* + 4, 1 */
	unsigned char cycle;	/* + 5, 1 */
	unsigned short name;	/* + 6, 2 z80_op_name_table[]̕ւ̃ItZbgł */
} Z80OP;			/* = 8    */
#define Z80OP_(CODE, PROC, ARGC, CYCLE, NAME)	{ z80op_##PROC, 0x##ARGC, 0x##CYCLE, 0x##NAME },
extern const Z80OP z80_op_table[256/*XX*/];		/* XX */
extern const Z80OP z80_op_table_CB[256/*XX*/];		/* CB XX */
extern const Z80OP z80_op_table_ED[256/*XX*/];		/* ED XX */
extern const Z80OP z80_op_table_DD[256/*XX*/];		/* DD XX */
extern const Z80OP z80_op_table_FD[256/*XX*/];		/* FD XX */
extern const Z80OP z80_op_table_DDCB[256/*XX*/];	/* DD CB ?? XX */
extern const Z80OP z80_op_table_FDCB[256/*XX*/];	/* FD CB ?? XX */
extern const char z80_op_name_table[];			/* j[jbNe[u */

/****************************************************************************
 *	֐
 ****************************************************************************/

/* Z80Zbgɐݒ肳AZ80RÃCREAD/WRITEEI/O IN/OUT̊O֐łB
 * AvP[V璼ڌĂяoƂ͂܂B
 */
unsigned char z80_internal_read (Z80* z80, unsigned short addr);
         void z80_internal_write(Z80* z80, unsigned short addr, unsigned char data);
unsigned char z80_internal_in   (Z80* z80, unsigned short addr);
         void z80_internal_out  (Z80* z80, unsigned short addr, unsigned char data);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* Z80Zbg܂B
 * [in]
 *	z80		Z80\́B
 * [note]
 *	* Z80Zbg̏Ԃł́AZ80RÃCREAD/WRITEEI/O IN/OUT̊O֐ݒ肳Ă܂B
 *	  Z80RÅO֐́Â悤ȓs܂B
 *
 *		READ	Z80\̂̒64KB̃CzuĂƉ肵ACǂݍ݂܂B
 *		WRITE	Z80\̂̒64KB̃CzuĂƉ肵ACɏ݂܂B
 *		IN	-1Ԃ܂B
 *		OUT	܂B
 *
 *	  Z80ZbgAKvɉāAAvP[V`READ/WRITEEIN/OUTO֐ŃI[o[ChĂB
 */
void z80_reset(Z80* z80);

/* Z80s܂B
 * [in]
 *	z80		Z80\́B
 *	cycle		sTCNB
 * [note]
 *	* sTCNcycleɒB邩A܂HALT܂Ŏs܂B
 *	  O҂̏ꍇAۂ̎sTCŃAcycleȂ\܂B
 *	  ҂̏ꍇAۂ̎sTCŃAcycleȂȂ\܂B
 *	* ̊֐߂ƂAz80->cycleɎcsTCNi[Ă܂B
 *	  Ⴆ cycle=100 ŌĂяoAۂɂ 105 TCNsꍇA  z80->cycle=-5 ƂȂ܂B
 *	  ܂A cycle=100 ŌĂяoA10 TCNs HALT ꍇ́Az80->cycle=90 ƂȂ܂B
 */
void z80_run(Z80* z80, int cycle);

/* }XN\荞݃NGXg𔭍s܂B
 * [in]
 *	z80		Z80\́B
 *	no		荞݃[hɂĈӖقȂ܂B
 *			[h0: RST XXH ߂̃IyR[hw肵܂B
 *			[h1: Ӗ܂B
 *			[h2: 荞݃xN^̉ʃoCgw肵܂B
 * [note]
 *	* 荞݂֎~ĂA荞݃NGXg͖܂B
 *	  荞݃NGXg͕ۗ܂B
 */
void z80_int(Z80* z80, unsigned char no);

/* }XNs荞݃NGXg𔭍s܂B
 * [in]
 *	z80		Z80\́B
 */
void z80_nmi(Z80* z80);

/* WG[o͂ɁAWX^_vs܂B
 * [in]
 *	z80		Z80\́B
 */
void z80_dump(Z80* z80);

#endif /*__CLIP_Z80_H__*/
