/*
 *	emu.c
 *
 *	MNV[EH[Y/EMU
 *
 *	* Tue Dec 05 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

unsigned char color_table[1 << 6];

/****************************************************************************
 *	
 ****************************************************************************/

static EMU g_emu;

void
emu_main(const GAME* game)
{
	EMU* emu = &g_emu;
	Z80* z80 = &emu->z80;

	int skip;
	int i;

	/* ܂[NAB */
	memset(emu, 0, sizeof(EMU));

	/* ROMǂݍ݁B */
	load_rom(game);

	/* |[gB */
	game->init(emu);

	/* CPUZbgB */
	z80_reset(z80);
	//z80->read = emu_read;
	//z80->write = EMU_VXrite;
	z80->in = emu_in;
	z80->out = emu_out;

	/* ʏB */
	init_video();

	for(;;) {
		schedule();
		if(joy & TRG_B) break; /* Q[I */

		/* ͍XVB */
		game->update_input(emu);

		for(skip = 0; skip <= EMU_SKIP; skip++) {
			/* 1t[񊄂荞ݔB */
			for(i = 0; i < 2; i++) {
				z80_run(z80, CPU_CYCLE / 2);
				z80_int(z80, i & 1 ? 0xcf : 0xd7);
			}
		}

		/* ʍXVB */
		update_video(emu);
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
load_rom(const GAME* game)
{
	EMU* emu = &g_emu;
	unsigned char* mem = emu->mem;
	const char* fname = game->fname;
	const ROM* rom = game->rom;

	int retval;
	unz_file_info ufi;

	/* ROMڑ̈̓ǂݏol-1Ɖ肵܂B */
	memset(mem, -1, 0x10000);

	/* ROMǂݍ݁B */
	while(rom->name) {
		retval = my_unzip(fname, rom->name, &mem[rom->base], rom->size, &ufi);
		if(retval != rom->size || ufi.crc != rom->crc) {
			die("ERR: %s", rom->name); /* G[bZ[WpceFontPrintf()ŗ̂Œ!! */
		}
		rom++;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
init_video()
{
	int i, j, n;

	/* `悵Ȃ̈NAB */
	memset(vbuff, 3, sizeof vbuff);

	/* kJ[e[u쐬B */
	for(i = 0; i <= (1 << 6) - 1; i++) {
		j = i;
		n = 0;
		while(j) {
			n += j & 1;
			j >>= 1;
		}
		color_table[i] = ((n + 1) / 2) ^ 3; /* {0,1,2,3,4,5,6}=>{3,2,2,1,1,0,0} */
	}
}

